#!/usr/bin/perl -w
############################## check_snmp_hp5400_temp.pl ########
my $Version='1.0';
# Date : 19 février 2019
# Author  : Nicolas Biersart
# Help : support@esia-sa.com
#################################################################

use strict;
use Net::SNMP;
use Getopt::Long;
use lib "/usr/local/esia/plugins/lib/perl"  ;
use ESIA::SNMP;
use ESIA::PLUGIN;
use ESIA::INVENTORY;
my $PROGNAME='get_snmp_inventory_default.pl';
my $PROGDESC = "get par défaut du module d'inventaire";
my $TIMEOUT = $ESIA::PLUGIN::TIMEOUT;
my %ERRORS= %ESIA::PLUGIN::ERRORS;
my $json;
my $return=$ERRORS{OK};
my ($opt_h,$opt_V);
#
#MAIN
#
&Getopt::Long::config('bundling');
#on récupère les paramètres SNMP
my ($snmp, $snmperror) = ESIA::SNMP::SessionAutoCommunityVersion(@ARGV);

GetOptions(
	"V"   => \$opt_V,	"version"    => \$opt_V,
	"h"   => \$opt_h,	"help"       => \$opt_h,
	"J" => \$json,	 "json" => \$json,
);
# -h & --help print help
if ($opt_h)
{
    #affiche l'aide par défaut
    ESIA::SNMP::print_snmp_usage($PROGNAME,'-T state');
    my @arr;
	push(@arr,["-T","--type","type of test [cpu,mem,env] (default: cpu)" ]);
	push(@arr,["-w","--warning","warning threshold in percent" ]);
	push(@arr,["-c","--critical","critical threshold in percent"]);
	ESIA::SNMP::print_snmp_help($PROGNAME,$PROGDESC,\@arr);
	exit $ERRORS{'OK'};
}
#on vérifie qu'on a bien un objet SNMP
if (!defined($snmp))
{
	print ("UNKNOWN: SNMP configuration error: $snmperror\n");
	exit $ERRORS{'UNKNOWN'};
}
if($json)
{
    my $out = ESIA::INVENTORY::getDefaultInventoryMib($snmp,$ESIA::INVENTORY::JSON);
    if($out eq "")
    {
        $return = $ERRORS{CRITICAL};
    }
    else
    {
        print "$out";
    }
}
else
{
    my $ret = ESIA::INVENTORY::getDefaultInventoryMib($snmp,$ESIA::INVENTORY::PRETTY);
    if($ret != 0)
    {
        $return = $ERRORS{CRITICAL};
    }
}
exit($return);
