#!/usr/bin/php
<?php
define('HTTP_PATH', '/usr/local/esia/public_html/');
define('NAME',"check_application.php");
define('DEFAULT_INVENTORY_SCAN',"/usr/local/esia/plugins/get_snmp_inventory_default.pl");
define('DEFAULT_INVENTORY_SCAN_PARAMETER','--json -H $IP $SNMP_PARAMETERS');
define('DEFAULT_INVENTORY_OS_SCAN',"/usr/local/esia/plugins/get_snmp_os_inventory.pl");
define('DEFAULT_INVENTORY_OS_SCAN_PARAMETER','--json -H $IP $SNMP_PARAMETERS -T $OSNAME');
define('DEFAULT_INVENTORY_PLUGIN_PARAMETER','--json -H $IP $SNMP_PARAMETERS -T inventory');
define('EDITOR_DB','editor.db.json');
$_SERVER['DOCUMENT_ROOT'] =HTTP_PATH;
include_once HTTP_PATH.'/esia.conf.php';
//Définition des paramètres d'exécution
$LONG_OPTS  = array("node:","groupnode:", "help",'debug');
$SHORT_OPTS ="n:g:hD";
$options = getopt($SHORT_OPTS, $LONG_OPTS);
$debug 	    = getParam($options,"D","Debug",NULL);
$listnode 	= getParam($options,"n","node",NULL);

include_once MVCMODEL;
include_once HTTP_PATH.'/Model_adm.php';

include_once HTTP_PATH.'/libs/logo_oid.hash.php';
trace($debug,'DATABASE CONNECTION');
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
trace($debug,'DATABASE CONNECTION SUCCESS');
//groupe de noeud 	static function getNodeList($dbconnection,$user_id=NULL,$group=NULL,$t_return = Model_esia::NODE_ASSOC )
// Noeud => instanceNode
// All
trace($debug,'IMPORTANTION MODEL INVENTORY');
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_INVENTORY');
$plugin_url = $arr[0]['apache_path'];
include_once  HTTP_PATH.$plugin_url.'/Model_inventory.php';
$editorDatabase = file_get_contents(HTTP_PATH.$plugin_url.EDITOR_DB);
$editorDatabase = json_decode($editorDatabase,true);
$group = null;
// on test s'il y a une groupe

trace($debug,'LOAD VALUE');
$manufacturerKnown = Model_inventory::getImportManufacturer($dbconnection);
trace($debug,$manufacturerKnown);
$componentType =Model_inventory::getImportType($dbconnection);
trace($debug,$componentType);
$modelKnown =Model_inventory::getImportComponent($dbconnection);

trace($debug,'GET NODE LIST');
$nodes= array();
if(!empty($listnode))
{
	$listnode = explode(',', $listnode);
	foreach($listnode as $nod)
	{
		$nodes[] = Model_esia::InstanceNode($dbconnection, $nod);
	}
}
else
{
	$nodes =  Model_esia::getNodeList($dbconnection,NULL,$group,Model_esia::NODE_INSTANCE);
}
trace($debug,'NODE SELECTED '.count($nodes));
$inventory_array = array();
$isbuilt_insert=0;
foreach($nodes as $node)
{
	$linkednodetab = false;
	try
	{
	    if(!empty($node->getSNMPVersion()))
	    {
	    	//Identification du fabricant
	    	trace($debug,$node->getName()." STARTED SCAN");
	    	$sysdescr = $node->getSysDescr();
	    	$objectid = $node->getSysObjectId();
	    	$is_gesa = false;
	    	if(@get_class($node)=='RemoteDevice')
	    	{
	    		$is_gesa = true;
	    	}
	    	$name = IANA::getSettingsName($objectid, $sysdescr);
	    	$pattern  = IANA::getPatternAdvised($is_gesa,$name);
	    	$patternfound = Model_adm::getPatternService($dbconnection,$pattern);
	    	$logo = IANA::getManufacturerLogo($objectid, $sysdescr);
            //
            //RECHERCHE SUR les OS
            //
	    	if($name =='linux' || $name =='windows')
	    	{
                //Récupération des OS et Application
	    		$parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_OS_SCAN_PARAMETER,$node);
	    		$parameter = str_replace('$OSNAME',"'".$logo['name']."'",$parameter);
	    		trace($debug, 'EXEC '.DEFAULT_INVENTORY_OS_SCAN." ".$parameter);
                $json = execImportPlugin(DEFAULT_INVENTORY_OS_SCAN,$parameter);
                foreach($json as $line)
                {
                    try
                    {
                        //recherche dans la base de donnée logiciel
                    	if(empty($line['manufacturer']))
                        {
	                        $editor = searchInEditorDatabase($line['name'],$editorDatabase);
	                        if(!empty($editor))
	                        {
	                        	if($line['type']=='SOFTWARE')
	                        	{
	                            	$line['type'] = $editor['type'];
	                        	}
	                        	if(!empty($editor['editor']))
	                        	{
	                            	$line['manufacturer'] = $editor['editor'];
	                        	}
	                        }
                        }
	                    $manufacturer = getManufacturerId($dbconnection,$line['manufacturer'],$manufacturerKnown);
	                    $type = getComponentType($dbconnection,$line['type'],'SOFTWARE',$componentType);
	                    $softId = getComponentId($modelKnown,$line['name'],$manufacturer,$type);
	                    if($softId === FALSE)
	                    {
							 // il faut ajouter le fabricant
	                         $softId = Model_inventory::addComponent($dbconnection,$line['name'],"","",$type,$manufacturer);
	                         $modelKnown[$softId]=array('model'=>$line['name'],'manufacturer'=>$manufacturer,'type'=>$type );
	                         echo "COMPONENT ADD  ".$line['name']."=".$softId." ".$line['type']."\n";
	                    }
                        echo "COMPONENT INFO ".$line['name']."=".$softId." ".$line['type']."\n";
                        $insert= Model_inventory::addSoftwareComponentOnNode($dbconnection,$node->getId(),$line['name'],
			                    												$line['fullname'],$softId,$line['version'],NULL);
                        if(is_numeric($insert))
                        {
                            $isbuilt_insert++;
                        }
                        $linkednodetab=true;

                    }
                    catch (Exception $e)
                    {
                        echo $node->getName()." INSERT OS ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['fullname'];
                        exit(0);
                    }
                }
                //Récupération des informations sur la machine
                $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
                $json = execImportPlugin(DEFAULT_INVENTORY_SCAN,$parameter.' -T os');
                foreach($json as $line)
                {
                    try
                    {
                            if($line['type']=='NETIN')
                            {
                                $vendor = Model_inventory::getVendorByMac($dbconnection,$line['option']['macAdress']);
                                $manufacturer= $vendor;
                            }
                            //returne l'identifiant du fabricant/éditeur associé, s'il n'existe pas. Il est ajouté en base de donnée
						    $manufacturer = getManufacturerId($dbconnection,$line['manufacturer'],$manufacturerKnown);
                            //returne l'identifiant du type de matériel, s'il n'existe pas il est ajouté.

                            $type = getComponentType($dbconnection,$line['type'],'HARDWARE',$componentType);
                            $model = getComponentId($modelKnown,$line['model'],$manufacturer,$type);
                            if($model === FALSE)
                            {
                                    // il faut ajouter le fabricant
                                $id = Model_inventory::addComponent($dbconnection,$line['name'],"$descr",$line['model'],$type,$manufacturer);
                                $modelKnown[$id]=array('model'=>$line['model'],'manufacturer'=>$manufacturer,'type'=>$type );

                                $model = $id;
                            }
                            $descr="";
                            $insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['name'],
			                        												$descr,'',$model,$line['firmwareVersion'],json_encode($line['option']));
                            if(is_numeric($insert))
                            {
                                $isbuilt_insert++;
                                $linkednodetab=true;
                            }

                    }
                    catch (Exception $e)
                    {
                    	echo $node->getName()." INSERT HARDWARE ERROR: ".$line['manufacturer']." T".$line['type']." ".$line['name']." mode".$line['model'];
                        exit(0);
                    }
                }
	    	}
            else
            {
                $flag_default_importation=TRUE;
	        	if(!empty($patternfound))
	        	{
	        		$list_exec = array();
	        		$patternfound = array_shift($patternfound);
	        		foreach($patternfound['plugins'] as $plug)
	        		{
	        			if(preg_match('#[CHECK|GESA]_SNMP#',$plug['plugin_name']))
	        			{
	        				if( !in_array($plug['path'],$list_exec))
	        				{
	        					$list_exec[] = 	$plug['path'];
	        				}

	        			}
	        		}
	        		//DEFAULT_INVENTORY_PLUGIN_PARAMETER
	        		foreach ($list_exec as $exec)
	        		{
	        			try
	        			{
						    $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_PLUGIN_PARAMETER,$node);
						    $json = execImportPlugin($exec,$parameter);
				            foreach($json as $line)
				            {
				                try
				                {

				                    //returne l'identifiant du fabricant/éditeur associé, s'il n'existe pas. Il est ajouté en base de donnée
									$manufacturer = getManufacturerId($dbconnection,$line['manufacturer'],$manufacturerKnown);
				                    //returne l'identifiant du type de matériel, s'il n'existe pas il est ajouté.
				                    $type="";
									if($type == 'OS')
									{
				                    	$type = getComponentType($dbconnection,$line['type'],'SOFTWARE',$componentType);
				                    }
				                    else
				                    {
				                    	$type = getComponentType($dbconnection,$line['type'],'HARDWARE',$componentType);
				                    }
				                    $descr = $line['model'].' '.$line['hardwareVersion'];
				                    $model = getComponentId($modelKnown,$line['model'],$manufacturer,$type);
				                    if($model === FALSE)
				                    {
				                            // il faut ajouter le fabricant
				                        $id = Model_inventory::addComponent($dbconnection,$line['name'],"$descr",$line['model'],$type,$manufacturer);
				                        $modelKnown[$id]=array('model'=>$line['model'],'manufacturer'=>$manufacturer,'type'=>$type );
				                        $model = $id;
				                    }
									echo "insert ".$node->getName()." ".$line['model']."\n";
				                    $insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['model'],
							                												$descr,$line['serial'],$model,$line['firmwareVersion'],NULL);
				                    if(is_numeric($insert))
				                    {
				                        $isbuilt_insert++;
				                        $linkednodetab=true;
				                    }

				                }
				                catch(Exception $e)
				                {
				                    echo $node->getName()." INSERT PLUGIN_PARAMETER ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
				                }
				            }
						}
	                    catch (Exception $e)
	                    {
	                        echo $node->getName()." INSERT PLUGIN_PARAMETER ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
	                    }
					}
	        	}
	        	//print_r($patternfound);
                //RECHER PAR DEFAUT SUR LES PATTERNS
	        	if($flag_default_importation)
	        	{
		            $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
		            $json = execImportPlugin(DEFAULT_INVENTORY_SCAN,$parameter);
                    foreach($json as $line)
                    {
                        try
                        {

                            //returne l'identifiant du fabricant/éditeur associé, s'il n'existe pas. Il est ajouté en base de donnée
						    $manufacturer = getManufacturerId($dbconnection,$line['manufacturer'],$manufacturerKnown);
                            //returne l'identifiant du type de matériel, s'il n'existe pas il est ajouté.

                            $type = getComponentType($dbconnection,$line['type'],'HARDWARE',$componentType);
                            $descr = $line['model'].' '.$line['hardwareVersion'];
                            $model = getComponentId($modelKnown,$line['model'],$manufacturer,$type);
                            if($model === FALSE)
                            {
                                    // il faut ajouter le fabricant
                                $id = Model_inventory::addComponent($dbconnection,$line['name'],"$descr",$line['model'],$type,$manufacturer);
                                $modelKnown[$id]=array('model'=>$line['model'],'manufacturer'=>$manufacturer,'type'=>$type );
                                $model = $id;
                            }
                            $insert= Model_inventory::addHardwareComponentOnNode($dbconnection,$node->getId(),$line['model'],
			                        												$descr,$line['serial'],$model,$line['firmwareVersion'],NULL);
                            if(is_numeric($insert))
                            {
                                $isbuilt_insert++;
                                $linkednodetab=true;
                            }

                        }
                        catch (Exception $e)
                        {
                            echo $node->getName()." INSERT PATTERN ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
                        }
                    }
	        	}
            }
	    }
	    //liaison automatique avec l'onglet Noeud
	    if($linkednodetab)
	    {
	   		Model_esia::addNodeTabs($dbconnection, $node->getId(), 'TAB_INVENTORY');
	    }
	}
	catch (SnmpException $e)
	{
		echo $node->getName()." SNMP ERROR: ".$e->getMessage();
	}
	catch (DeviceSnmpException $e)
	{
		echo $node->getName()." SNMP ERROR: ".$e->getMessage();
	}
	catch (Exception $e)
	{
		echo $node->getName()." GLOBAL ERROR: ".$e->getMessage();
	}
}
function getParam($options, $shortName, $slongName, $default = null)
{
    $param = $default;
    if (isset($options[$shortName]))
    {
        $param = $options[$shortName];
    }
    elseif (isset($options[$slongName]))
    {
        $param = $options[$slongName];
    }
    // security for string
    if (is_string($param))
    {
        $param = strtolower(trim(str_replace(' ', '', $param)));
    }
    return $param;
}
function getManufacturerId($dbconnection,$manufacturer,&$array)
{
    if(empty($manufacturer))
    {
        $manufacturer="unknown";
    }
    $result = FALSE;
    foreach($array as $key => $man)
    {
        if(stripos($man, $manufacturer) !== FALSE)
        {
            $result =$key;
            break;
        }
    }
    if($result === FALSE)
    {
        // il faut ajouter le fabricant
        $id = Model_inventory::addManufacturer($dbconnection,$manufacturer);
        $array[$id]=$manufacturer;
        $result = $id;
    }
    return $result;
}
function getComponentType($dbconnection,$name,$type,&$array)
{
    if(empty($name))
    {
        $name="SOFTWARE";
    }
    $result = FALSE;
    $tmp = strtoupper($name);
    foreach($array as $key => $man)
    {
        if($man == $tmp)
        {
            $result =$key;
            break;
        }
    }
    if($result === FALSE)
    {
        // il faut ajouter le type
        $id = Model_inventory::addType($dbconnection,$tmp,$type);
        $array[$id]=$tmp;
        $result = $id;
    }
    return $result;
}
function getComponentId($array,$model,$manufacturer,$type)
{
    $result = FALSE;
    foreach($array as $key => $man)
    {
    	if($man['type'] == $type)
    	{
	    	if($man['manufacturer'] == $manufacturer)
	    	{
	    		if($man['model']==$model)
	    		{
	    			$result =$key;
	    			break;
	    		}
	    	}
    	}
    }
    return $result;
}
function trace($debug,$output)
{
	//if($debug==1 || $debug===true)
	if(isset($debug))
	{
		if(is_array($output))
		{
			print_r($output);
		}
		else
		{
			echo "DEBUG: $output\n";
		}
	}
}
function execImportPlugin($path,$parameter)
{
    exec("$path $parameter",$arr,$ret);
    $output="";
    foreach($arr as $line)
    {
        $output.=$line;
    }
    $output = trim($output);
    if($ret == 0)
    {
        $json = json_decode($output,true);
        //On test si le JSON est valide
        if(json_last_error() === JSON_ERROR_NONE)
        {
            return $json;
        }
        else
        {
            throw new Exception("BAD JSON FORMAT error $output");
        }
    }
    else
    {
        throw new Exception("Exec error $path $parameter");
    }
}
function defaultHardwareImportation($dbconnection,$node)
{
    $arr= NULL;
		        $parameter = Model_esia::getServiceExecutableParameters($dbconnection,DEFAULT_INVENTORY_SCAN_PARAMETER,$node);
		        $json = execImportPlugin(DEFAULT_INVENTORY_SCAN,$parameter);
		                foreach($json as $line)
		                {
		                	try
		                	{
			                	if(empty($line['manufacturer']))
			                	{
			                		$line['manufacturer']="unknown";
			                	}
								$manufacturer = manufacturer_exist($line['manufacturer'],$manufacturerKnown);
				                if($manufacturer === FALSE)
								{
				                        // il faut ajouter le fabricant
									$id = Model_inventory::addManufacturer($dbconnection,$line['manufacturer']);
									$manufacturerKnown[$id]=$line['manufacturer'];
									$manufacturer = $id;
				                }
				                $tmp = strtoupper($line['type']);
				                $type = type_exist($tmp,$hardwareType);
			                    if($type === FALSE)
			                    {
			                        // il faut ajouter le type
			                    	$id = Model_inventory::addType($dbconnection,$tmp,'HARDWARE');
			                    	$hardwareType[$id]=$tmp;
			                    	$type = $id;
			                    }
			                    $descr = $line['model'].' '.$line['hardwareVersion'];
			                    $model = model_exist($modelKnown,$line['model'],$manufacturer,$type);
			                    if($model === FALSE)
			                    {
			                        // il faut ajouter le fabricant
			                    	$id = Model_inventory::addComponent($dbconnection,$line['name'],"$descr",$line['model'],$type,$manufacturer);
			                    	$modelKnown[]=array('model'=>$line['model'],'manufacturer'=>$manufacturer,'type'=>$type );
			                    	$model = $id;
			                    }
			                    $insert= Model_inventory::addComponentOnNode($dbconnection,$node->getId(),$line['model'],
			                    												$descr,$line['serial'],$model,$line['firmwareVersion'],NULL);
			                    if(is_numeric($insert))
			                    {
			                    	$isbuilt_insert++;
			                    }

		                	}
		                	catch (Exception $e)
		                	{
		                		echo $node->getName()." INSERT defaultHardwareImportation ERROR: ".$line['manufacturer']." ".$line['type']." ".$line['serial'];
		                	}
		                }
}
function searchInEditorDatabase($search,$editorDatabase)
{
    $return = NULL;
    foreach($editorDatabase as $item)
    {
        if(stripos($search,$item['name'])!==FALSE)
        {
            $return = $item;
            break;
        }
    }
    return $return;
}
?>
